package org.nakedobjects.nof.core.service;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.nakedobjects.noa.NakedObjectRuntimeException;
import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.nof.core.context.NakedObjectsContext;

public class ServiceUtil {

    public static String id(Object object) {
        if(object instanceof SimpleRepository) {
            return "repository#" + ((SimpleRepository) object).getSpec().getFullName();
        }
        Class cls = object.getClass();
        try {
            Method m = cls.getMethod("getId", new Class[0]);
            return (String) m.invoke(object, new Object[0]);
        } catch (SecurityException e) {
            throw new NakedObjectRuntimeException(e);
        } catch (NoSuchMethodException e) {
            String id = object.getClass().getName();
            return id.substring(id.lastIndexOf('.') + 1);
        } catch (IllegalArgumentException e) {
            throw new NakedObjectRuntimeException(e);
        } catch (IllegalAccessException e) {
            throw new NakedObjectRuntimeException(e);
        } catch (InvocationTargetException e) {
            throw new NakedObjectRuntimeException(e);
        }
    }

    public static String title(Object service) {
        NakedObject adapter = NakedObjectsContext.getObjectLoader().getAdapterFor(service);
        return adapter.titleString();
    }

    
}


// Copyright (c) Naked Objects Group Ltd.
