package org.nakedobjects.nof.core.system;

/**
 * This interface marks a class as able to install a component for the NOF during it boot strapping process.
 * All installers listed (by class name) in framework.properties are loaded when the boot strap class is
 * initially loaded. Then named installers are used during boot to create components for the system. The name
 * method specified is the name that the component can be installed by.
 */
public interface Installer {
    String getName();
    
    /*
     * TODO add:
     * String getDescription();
     */
}

// Copyright (c) Naked Objects Group Ltd.
